package edu.sc.sasimulator;


/** An event. 
 * @author Jose M. Vidal
 * @version $Revision: 1.1.1.1 $, $Date: 2000/04/07 16:01:07 $
 */
public class Event {
    /** The time at which this event should take place */
    public long time;

    /** The type of event*/
    public int type;

    /** The object to whom this event corresponds. */
    public Thing thing;


    Event() {
	time = 0;
	type = 0;
	thing = null;
    }

    Event(long t, int ty, Thing th){
	time = t;
	type = ty;
	thing = th;
    }

    /** Does this event happen before e?
	@param e the other event
	@return time < e.time */
    public boolean isBefore(Event e){
	return (time < e.time);
    }

    public String toString(){
	return (time + "-" + type + " " + thing.getName());
    }

}
