package edu.sc.sasimulator;
import java.util.*;
/** 
 * All agents and services are Things. This should be an interface...maybe soon.
 * @author Jose M. Vidal
 * @version $Revision: 1.3 $, $Date: 2000/04/25 19:23:14 $
 */
public class Thing {

    /** Handle the event. */
    public boolean doEvent(int type){
	return false;};

    /** My name */
    protected String name;

    /**
       * Get the value of name.
       * @return Value of name.
       */
    public String getName() {return name;}
    
    /**
       * Set the value of name.
       * @param v  Value to assign to name.
       */
    public void setName(String  v) {this.name = v;}
    

    protected double xLocation;
    
    /**
       * Get the value of xLocation.
       * @return Value of xLocation.
       */
    public double getXLocation() {return xLocation;}
    
    /**
       * Set the value of xLocation.
       * @param v  Value to assign to xLocation.
       */
    public void setXLocation(double  v) {this.xLocation = v;}
    
    
    protected double yLocation;
    
    /**
       * Get the value of yLocation.
       * @return Value of yLocation.
       */
    public double getYLocation() {return yLocation;}
    
    /**
       * Set the value of yLocation.
       * @param v  Value to assign to yLocation.
       */
    public void setYLocation(double  v) {this.yLocation = v;}
    
    protected Simulator simulator;

    public Thing (Simulator sm, String n, double x, double y){
	xLocation = x;
	yLocation = y;
	simulator = sm;
	name = n;
    }

    /** Picks a random element for the vector and returns it
     * @param v the vector of elements
     * @return one of the elements, null if v has no elements*/
    public static Object pickOne(Vector v){
	if (v.size() == 0) 
	    return null;
	int i = (int)(Math.random()*v.size());
	return v.elementAt(i);
    }

    /** Picks a random subset of elements
     * @param v the original vector of elements
     * @param n the number of elements we want picked
     * @return a new vector with all the picked elements */
    public static Vector pickSome(Vector v, int n){
	if (n > v.size()){
	    return (Vector)v.clone();
	}
	Vector r = new Vector();
	for (int i =0; i < n; i++){
	    r.add(pickOne(v));
	}
	return r;
    }

    public String toString(){
	String s = name + " " + xLocation + "," + yLocation;
	return s;
    }

    /** The utility I get from a. This function should be redifined by the
	inheriting classes */
    public double utility(Allocation a){
	return 0;
    }

}
